// Code generated by vpplink DO NOT EDIT.
// Copyright (C) 2019 Cisco Systems Inc.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//    http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or
// implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package generated

import (
	"fmt"
	"io"

	types "github.com/calico-vpp/vpplink/api/v0"
	"github.com/projectcalico/vpp-dataplane/v3/vpplink/generated/bindings/interface_types"
	"github.com/projectcalico/vpp-dataplane/v3/vpplink/generated/bindings/ip_types"
	"github.com/projectcalico/vpp-dataplane/v3/vpplink/generated/bindings/ipip"
)

func (v *Vpp) ListIPIPTunnels() ([]*types.IPIPTunnel, error) {
	client := ipip.NewServiceClient(v.conn)

	stream, err := client.IpipTunnelDump(v.ctx, &ipip.IpipTunnelDump{
		SwIfIndex: interface_types.InterfaceIndex(types.InvalidInterface),
	})
	if err != nil {
		return nil, fmt.Errorf("failed to list IPIP tunnels: %w", err)
	}
	var tunnels []*types.IPIPTunnel
	for {
		response, err := stream.Recv()
		if err == io.EOF {
			break
		}
		if err != nil {
			return nil, fmt.Errorf("failed to list IPIP tunnels: %w", err)
		}
		tunnels = append(tunnels, &types.IPIPTunnel{
			Src:       response.Tunnel.Src.ToIP(),
			Dst:       response.Tunnel.Dst.ToIP(),
			TableID:   response.Tunnel.TableID,
			SwIfIndex: uint32(response.Tunnel.SwIfIndex),
		})
	}
	return tunnels, nil
}

func (v *Vpp) AddIPIPTunnel(tunnel *types.IPIPTunnel) (uint32, error) {
	client := ipip.NewServiceClient(v.conn)

	response, err := client.IpipAddTunnel(v.ctx, &ipip.IpipAddTunnel{
		Tunnel: ipip.IpipTunnel{
			Instance: ^uint32(0),
			Src:      ip_types.NewAddress(tunnel.Src),
			Dst:      ip_types.NewAddress(tunnel.Dst),
			TableID:  tunnel.TableID,
		},
	})
	if err != nil {
		return InvalidSwIfIndex, fmt.Errorf("failed to add IPIP tunnel: %w", err)
	}
	tunnel.SwIfIndex = uint32(response.SwIfIndex)
	return uint32(response.SwIfIndex), nil
}

func (v *Vpp) DelIPIPTunnel(tunnel *types.IPIPTunnel) error {
	client := ipip.NewServiceClient(v.conn)

	_, err := client.IpipDelTunnel(v.ctx, &ipip.IpipDelTunnel{
		SwIfIndex: interface_types.InterfaceIndex(tunnel.SwIfIndex),
	})
	if err != nil {
		return fmt.Errorf("failed to delete IPIP tunnel: %w", err)
	}
	return nil
}
